/****************************************************************************
*       data.c
*
* **********************************************************************
* *     Copyright (c) by Barak Pearlmutter and Kevin Lang, 1987-99.    *
* *     Copyright (c) by Alex Stuebinger, 1998-99.                     *
* *     Placed under the terms of the GNU General Public License       *
* *     as published by the Free Software Foundation.                  *
* **********************************************************************
*
*/

/* This file contains many tunable parameters */

#include "config.h"
#include "data.h"


/* Version and greeting */
const char *version = "1.00", *compilation_date = __DATE__, *compilation_time = __TIME__;

/* byte gender */
int byte_gender = little_endian;


/* spaces */

space_t new_space, old_space, spatic;
ref_t *free_point = 0;


/* stacks */

stack_t value_stack = {0, 0, 0, 0};
stack_t context_stack = {0, 0, 0, 0};


#ifndef STACKS_STATIC
int value_stack_size, context_stack_size;
int value_stack_hysteresis, context_stack_hysteresis;
#else
ref_t VAL_STACK[value_stack_size + 2];
ref_t CON_STACK[context_stack_size + 2];
#endif


/* Weak pointer table and weak pointer hashtable */

const int wp_table_size = 3000;
const int wp_hashtable_size = 3017;


/* Virtual Machine registers */

ref_t *e_bp, *e_env, e_t, e_nil, e_fixnum_type, e_loc_type, e_cons_type,
  e_env_type, *e_subtype_table, e_object_type, e_segment_type, e_boot_code,
  e_code_segment, *e_arged_tag_trap_table, *e_argless_tag_trap_table,
  e_current_method, e_uninitialized, e_method_type, e_operation_type;

size_t e_next_newspace_size, original_newspace_size;

unsigned short *e_pc;

unsigned e_nargs = 0;

char *world_file_name = "/home/bap/usr/oaklisp/src/lib/oakworld-lit";
char *dump_file_name = NULL;
int dump_base = 2;		/* 2=binary, other=ascii */

bool dump_flag = false;
bool quiet_flag = false;

/* to be rewritten */
bool trace_gc = false;

bool gc_shutup = true;

/* virtual machine defaults and configuration */


#ifdef NOTBAP

#ifndef STACKS_STATIC

const config_t
  default_config =
{16 * 1024 - 2, 256, 4 * 1024 - 2, 64, 1024 * 1024 / 4,
 "oaklisp.++c", "oak99dum.bin", 2}, compiler_config =
{16 * 1024 - 2, 256, 4 * 1024 - 2, 64, 1024 * 1024 / 4,
 "oaklisp.++z", "oak99dum.bin", 2}, small_config =
{2 * 1024 - 2, 32, 1024 - 2, 16, 128 * 1024 / 4,
 "oaklisp.++c", "oak99dum.bin", 2}, large_config =
{64 * 1024 - 2, 512, 16 * 1024 - 2, 128, 8 * 1024 * 1024 / 4,
 "oaklisp.++c", "oak99dum.bin", 2};

#else

const config_t
  default_config =
{1024 * 1024 / 4,
 "oaklisp.++c", "oak99dum.bin", 2}, compiler_config =
{1024 * 1024 / 4,
 "oaklisp.++z", "oak99dum.bin", 2}, small_config =
{128 * 1024 / 4,
 "oaklisp.++c", "oak99dum.bin", 2}, large_config =
{8 * 1024 * 1024 / 4,
 "oaklisp.++c", "oak99dum.bin", 2};

#endif
#endif
